#include <windows.h>
#define  WIN32_LEAN_AND_MEAN

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <errno.h>
#include <fcntl.h>
#include <io.h>
#include <stdio.h>
#include <sys/locking.h>
#include <sys/types.h>

#define CONST_DEF(xxx) if (strEQ(name, #xxx ))   \
                        return xxx

static char buffer[1];         /* small smothing stashed away */

#define sys_errno (*_errno())

static int
not_here(
CPerl *pPerl,
char *s)
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(
CPerl *pPerl,
char *name,
int arg)
{
    errno = 0;
    switch (*name)
    {
    case 'E':
        CONST_DEF(EDEADLOCK);
        break;
    case 'L':
        if(strnEQ(name, "LK_", 3))
        {
            CONST_DEF(LK_LOCK);
            CONST_DEF(LK_RLCK);
            CONST_DEF(LK_NBLCK);
            CONST_DEF(LK_NBRLCK);
            CONST_DEF(LK_UNLCK);
        }
        break;
    case 'S':
        if(strnEQ(name, "SEEK_", 5))
        {
            CONST_DEF(SEEK_SET);
            CONST_DEF(SEEK_CUR);
            CONST_DEF(SEEK_END);
        } else if(strnEQ(name, "S_I", 3))
        {
            CONST_DEF(S_IRUSR);
            CONST_DEF(S_IWUSR);
            CONST_DEF(S_IXUSR);
            CONST_DEF(S_IRGRP);
            CONST_DEF(S_IWGRP);
            CONST_DEF(S_IXGRP);
            CONST_DEF(S_IROTH);
            CONST_DEF(S_IWOTH);
            CONST_DEF(S_IXOTH);
            CONST_DEF(S_IREAD);
            CONST_DEF(S_IWRITE);
            CONST_DEF(S_IEXEC);

            if (strEQ(name, "S_IRWXU"))
#ifdef          S_IRWXU
                return S_IRWXU
#else
                goto not_there;
#endif
            if (strEQ(name, "S_IRWXG"))
#ifdef          S_IRWXG
                return S_IRWXG
#else
                goto not_there;
#endif
            if (strEQ(name, "S_IRWXO"))
#ifdef          S_IRWXO
                return S_IRWXO
#else
                goto not_there;
#endif
        }
        break;
    case '_':
        if(strnEQ(name, "_LK_", 4))
        {
            CONST_DEF(_LK_LOCK);
            CONST_DEF(_LK_RLCK);
            CONST_DEF(_LK_NBLCK);
            CONST_DEF(_LK_NBRLCK);
            CONST_DEF(_LK_UNLCK);
        }
        break;
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}


MODULE = Win32::file PACKAGE = Win32::file

# # /************************************************************/

double
constant(name,arg)
	char *		name
	int		arg
    CODE:
    {
        RETVAL=constant(pPerl, name, arg);
/*        printf("Looking for %s, found %f\n", name, RETVAL); */
    }
    OUTPUT:
    RETVAL

# /************************************************************/

int
_locking(hndl,lock,size)
    int     hndl
    int     lock
    int     size
    CODE:
    {
        errno=0;
        RETVAL=_locking(hndl, lock, size);
        if(RETVAL!=0)
            errno=sys_errno;
    }
    OUTPUT:
    RETVAL

# /************************************************************/

int
_open(name, flags, ...)
    char*   name
    int     flags
    CODE:
    {
        errno=0;
        int mode=0;
        if(items==3)
            mode=(int)SvIV(ST(3));

        RETVAL=_open(name, flags, mode);
        if(-1==RETVAL)
            errno=sys_errno;
    }
    OUTPUT:
    RETVAL

# /************************************************************/

int
_close(hndl)
    int     hndl;
    CODE:
    {
        errno=0;
        RETVAL=_close(hndl);
        if(-1==RETVAL)
            errno=sys_errno;
    }
    OUTPUT:
    RETVAL

# /************************************************************/

int
_read(hndl, mybuf, size)
    int     hndl;
    char*   mybuf;
    int     size;
    CODE:
    {
        errno=0;
        RETVAL=read(hndl, mybuf, size);
        if(size!=RETVAL)
            errno=sys_errno;
    }
    OUTPUT:
    RETVAL

# /************************************************************/

int
_write(hndl, buffer, size)
    int     hndl;
    char*   buffer;
    int     size;
    CODE:
    {
        errno=0;
        RETVAL=write(hndl, buffer, size);
        if(size!=RETVAL)
            errno=sys_errno;
    }
    OUTPUT:
    RETVAL

# /************************************************************/

long
_tell(hndl)
    int     hndl;
    CODE:
    {
        errno=0;
        RETVAL=tell(hndl);
        if(-1==RETVAL)
            errno=sys_errno;
    }
    OUTPUT:
    RETVAL

# /************************************************************/
long
_lseek(hndl, pos, from)
    int     hndl;
    long    pos;
    int     from;
    CODE:
    {
        errno=0;
        RETVAL=_lseek(hndl, pos, from);
        if(-1==RETVAL)
            errno=sys_errno;
    }
    OUTPUT:
    RETVAL


# /************************************************************/

long
_setmode(hndl, mode)
    int     hndl;
    int     mode;
    CODE:
    {
        errno=0;
        RETVAL=setmode(hndl, mode);
        if(-1==RETVAL)
            errno=sys_errno;
    }
    OUTPUT:
    RETVAL

# /************************************************************/

long
_filelength(hndl)
    int     hndl;
    CODE:
    {
        errno=0;
        RETVAL=filelength(hndl);
        if(-1==RETVAL)
            errno=sys_errno;
    }
    OUTPUT:
    RETVAL

# /************************************************************/
char*
__tmpfname(file)
    FILE*   file
    CODE:
    {
        RETVAL=file->_tmpfname;
    }
    OUTPUT:
    RETVAL

# /************************************************************/

char*
GetWindowsDirectory()
    CODE:
    {
        int ret;
        int length=GetWindowsDirectory(buffer, 1); /* this will fail */

        New(0, RETVAL, length+1, char);         /* but returns size of buffer*/
        ret=GetWindowsDirectory(RETVAL, length);

        if(1+ret!=length)                       /* huh? */
        {   Safefree(RETVAL);                   /* no way should this happen*/
            errno=ENOSYS;                       /* so return a almost */
            RETVAL="";                          /* meaning-full value */
        }
    }
    OUTPUT:
    RETVAL



# /************************************************************/

char*
GetSystemDirectory()
    CODE:
    {
        int ret;
        int length=GetSystemDirectory(buffer, 1); /* this will fail */

        New(0, RETVAL, length+1, char);         /* but returns size of buffer*/
        ret=GetSystemDirectory(RETVAL, length);

        if(1+ret!=length)                       /* huh? */
        {   Safefree(RETVAL);                   /* no way should this happen*/
            errno=ENOSYS;                       /* so return an almost */
            RETVAL="";                          /* meaning-full value */
        }
    }
    OUTPUT:
    RETVAL

# /************************************************************/

char*
GetCurrentDirectory()
    CODE:
    {
        int ret;
        int length=GetCurrentDirectory(1, buffer); /* this will fail */

        New(0, RETVAL, length+1, char);         /* but returns size of buffer*/
        ret=GetCurrentDirectory(length, RETVAL);

        if(1+ret!=length)                       /* huh? */
        {   Safefree(RETVAL);                   /* no way should this happen*/
            errno=ENOSYS;                       /* so return an almost */
            RETVAL="";                          /* meaning-full value */
        }
    }
    OUTPUT:
    RETVAL



